using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Net;
using System.Net.Sockets;
using System.IO;
using System.Text;
using System.Threading;
using System.Timers;

namespace RobotClient
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class RobotClient : System.Windows.Forms.Form
	{
		private NetworkStream commandStream;
		private TcpClient connectionOut = null;

		private NetworkStream feedbackStream;
		private TcpClient connectionIn = null;

		private NetworkStream imageStream;
		private TcpClient connectionImg = null;

		private System.Timers.Timer getImageTimer;
		private System.Timers.Timer getFeedbackTimer;
		private Color defColor;

		//sensor warning flags
		bool leftf = false, rightf = false, frontf= false, bottomf= false; 
		
		private string movementType = "inc\n";

		private System.Windows.Forms.Button btnFoward;
		private System.Windows.Forms.Button btnRight;
		private System.Windows.Forms.Button btnLeft;
		private System.Windows.Forms.Button btnBack;
		private System.Windows.Forms.TextBox txtIP;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Button btnConnect;
		private System.Windows.Forms.TextBox txtStatus;
		private System.Windows.Forms.RadioButton rdoInc;
		private System.Windows.Forms.RadioButton rdoCont;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.GroupBox groupBox3;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Button btnStop;
		private System.Windows.Forms.TrackBar tbSpeed;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.PictureBox picVideo;
		private System.Windows.Forms.TrackBar tbImageRefresh;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Button btnAuto;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public RobotClient()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.btnFoward = new System.Windows.Forms.Button();
			this.btnRight = new System.Windows.Forms.Button();
			this.btnLeft = new System.Windows.Forms.Button();
			this.btnBack = new System.Windows.Forms.Button();
			this.txtIP = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.picVideo = new System.Windows.Forms.PictureBox();
			this.btnConnect = new System.Windows.Forms.Button();
			this.txtStatus = new System.Windows.Forms.TextBox();
			this.rdoInc = new System.Windows.Forms.RadioButton();
			this.rdoCont = new System.Windows.Forms.RadioButton();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.tbImageRefresh = new System.Windows.Forms.TrackBar();
			this.label4 = new System.Windows.Forms.Label();
			this.groupBox3 = new System.Windows.Forms.GroupBox();
			this.btnAuto = new System.Windows.Forms.Button();
			this.label3 = new System.Windows.Forms.Label();
			this.tbSpeed = new System.Windows.Forms.TrackBar();
			this.btnStop = new System.Windows.Forms.Button();
			this.label2 = new System.Windows.Forms.Label();
			this.groupBox1.SuspendLayout();
			this.groupBox2.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.tbImageRefresh)).BeginInit();
			this.groupBox3.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.tbSpeed)).BeginInit();
			this.SuspendLayout();
			// 
			// btnFoward
			// 
			this.btnFoward.Location = new System.Drawing.Point(152, 56);
			this.btnFoward.Name = "btnFoward";
			this.btnFoward.Size = new System.Drawing.Size(56, 32);
			this.btnFoward.TabIndex = 0;
			this.btnFoward.Text = "Foward";
			this.btnFoward.Click += new System.EventHandler(this.btnFoward_Click);
			// 
			// btnRight
			// 
			this.btnRight.Location = new System.Drawing.Point(216, 104);
			this.btnRight.Name = "btnRight";
			this.btnRight.Size = new System.Drawing.Size(56, 32);
			this.btnRight.TabIndex = 1;
			this.btnRight.Text = "Turn Right";
			this.btnRight.Click += new System.EventHandler(this.btnRight_Click);
			// 
			// btnLeft
			// 
			this.btnLeft.Location = new System.Drawing.Point(88, 104);
			this.btnLeft.Name = "btnLeft";
			this.btnLeft.Size = new System.Drawing.Size(56, 32);
			this.btnLeft.TabIndex = 2;
			this.btnLeft.Text = "Turn Left";
			this.btnLeft.Click += new System.EventHandler(this.btnLeft_Click);
			// 
			// btnBack
			// 
			this.btnBack.Location = new System.Drawing.Point(152, 152);
			this.btnBack.Name = "btnBack";
			this.btnBack.Size = new System.Drawing.Size(56, 32);
			this.btnBack.TabIndex = 3;
			this.btnBack.Text = "Back";
			this.btnBack.Click += new System.EventHandler(this.btnBack_Click);
			// 
			// txtIP
			// 
			this.txtIP.Location = new System.Drawing.Point(184, 16);
			this.txtIP.Name = "txtIP";
			this.txtIP.Size = new System.Drawing.Size(112, 20);
			this.txtIP.TabIndex = 4;
			this.txtIP.Text = "66.92.77.183";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(128, 16);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(56, 32);
			this.label1.TabIndex = 5;
			this.label1.Text = "Server IP";
			// 
			// picVideo
			// 
			this.picVideo.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.picVideo.Location = new System.Drawing.Point(8, 16);
			this.picVideo.Name = "picVideo";
			this.picVideo.Size = new System.Drawing.Size(320, 240);
			this.picVideo.TabIndex = 7;
			this.picVideo.TabStop = false;
			// 
			// btnConnect
			// 
			this.btnConnect.Location = new System.Drawing.Point(312, 16);
			this.btnConnect.Name = "btnConnect";
			this.btnConnect.Size = new System.Drawing.Size(80, 24);
			this.btnConnect.TabIndex = 9;
			this.btnConnect.Text = "Connect";
			this.btnConnect.Click += new System.EventHandler(this.btnConnect_Click);
			// 
			// txtStatus
			// 
			this.txtStatus.BackColor = System.Drawing.SystemColors.HighlightText;
			this.txtStatus.Location = new System.Drawing.Point(16, 16);
			this.txtStatus.Multiline = true;
			this.txtStatus.Name = "txtStatus";
			this.txtStatus.ReadOnly = true;
			this.txtStatus.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this.txtStatus.Size = new System.Drawing.Size(760, 112);
			this.txtStatus.TabIndex = 11;
			this.txtStatus.Text = "";
			// 
			// rdoInc
			// 
			this.rdoInc.Checked = true;
			this.rdoInc.Location = new System.Drawing.Point(272, 48);
			this.rdoInc.Name = "rdoInc";
			this.rdoInc.Size = new System.Drawing.Size(88, 16);
			this.rdoInc.TabIndex = 12;
			this.rdoInc.TabStop = true;
			this.rdoInc.Text = "Incremental";
			this.rdoInc.CheckedChanged += new System.EventHandler(this.rdoInc_CheckedChanged);
			// 
			// rdoCont
			// 
			this.rdoCont.Location = new System.Drawing.Point(272, 72);
			this.rdoCont.Name = "rdoCont";
			this.rdoCont.Size = new System.Drawing.Size(88, 16);
			this.rdoCont.TabIndex = 13;
			this.rdoCont.Text = "Continuous";
			this.rdoCont.CheckedChanged += new System.EventHandler(this.rdoCont_CheckedChanged);
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.Add(this.txtStatus);
			this.groupBox1.Location = new System.Drawing.Point(24, 304);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(784, 136);
			this.groupBox1.TabIndex = 14;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Status";
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.Add(this.tbImageRefresh);
			this.groupBox2.Controls.Add(this.picVideo);
			this.groupBox2.Controls.Add(this.label4);
			this.groupBox2.Location = new System.Drawing.Point(424, 16);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(384, 264);
			this.groupBox2.TabIndex = 15;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "Video Feed";
			// 
			// tbImageRefresh
			// 
			this.tbImageRefresh.LargeChange = 50;
			this.tbImageRefresh.Location = new System.Drawing.Point(336, 56);
			this.tbImageRefresh.Maximum = 1000;
			this.tbImageRefresh.Minimum = 100;
			this.tbImageRefresh.Name = "tbImageRefresh";
			this.tbImageRefresh.Orientation = System.Windows.Forms.Orientation.Vertical;
			this.tbImageRefresh.Size = new System.Drawing.Size(45, 200);
			this.tbImageRefresh.TabIndex = 8;
			this.tbImageRefresh.TickFrequency = 25;
			this.tbImageRefresh.Value = 1000;
			this.tbImageRefresh.Scroll += new System.EventHandler(this.tbImageRefresh_Scroll);
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(328, 24);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(48, 24);
			this.label4.TabIndex = 18;
			this.label4.Text = "Refresh Rate";
			this.label4.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// groupBox3
			// 
			this.groupBox3.Controls.Add(this.btnAuto);
			this.groupBox3.Controls.Add(this.label3);
			this.groupBox3.Controls.Add(this.tbSpeed);
			this.groupBox3.Controls.Add(this.btnStop);
			this.groupBox3.Controls.Add(this.label2);
			this.groupBox3.Controls.Add(this.btnLeft);
			this.groupBox3.Controls.Add(this.rdoCont);
			this.groupBox3.Controls.Add(this.rdoInc);
			this.groupBox3.Controls.Add(this.btnFoward);
			this.groupBox3.Controls.Add(this.btnBack);
			this.groupBox3.Controls.Add(this.btnRight);
			this.groupBox3.Enabled = false;
			this.groupBox3.Location = new System.Drawing.Point(24, 56);
			this.groupBox3.Name = "groupBox3";
			this.groupBox3.Size = new System.Drawing.Size(368, 224);
			this.groupBox3.TabIndex = 16;
			this.groupBox3.TabStop = false;
			this.groupBox3.Text = "Movement";
			// 
			// btnAuto
			// 
			this.btnAuto.Location = new System.Drawing.Point(280, 184);
			this.btnAuto.Name = "btnAuto";
			this.btnAuto.Size = new System.Drawing.Size(80, 32);
			this.btnAuto.TabIndex = 18;
			this.btnAuto.Text = "Autonomous Mode";
			this.btnAuto.Click += new System.EventHandler(this.btnAuto_Click);
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(8, 24);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(56, 16);
			this.label3.TabIndex = 17;
			this.label3.Text = "Speed";
			// 
			// tbSpeed
			// 
			this.tbSpeed.Location = new System.Drawing.Point(16, 48);
			this.tbSpeed.Maximum = 50;
			this.tbSpeed.Name = "tbSpeed";
			this.tbSpeed.Orientation = System.Windows.Forms.Orientation.Vertical;
			this.tbSpeed.Size = new System.Drawing.Size(45, 168);
			this.tbSpeed.TabIndex = 16;
			this.tbSpeed.Value = 20;
			this.tbSpeed.MouseUp += new System.Windows.Forms.MouseEventHandler(this.tbSpeed_MouseUp);
			// 
			// btnStop
			// 
			this.btnStop.Location = new System.Drawing.Point(152, 104);
			this.btnStop.Name = "btnStop";
			this.btnStop.Size = new System.Drawing.Size(56, 32);
			this.btnStop.TabIndex = 15;
			this.btnStop.Text = "Stop";
			this.btnStop.Click += new System.EventHandler(this.btnStop_Click);
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(272, 24);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(88, 24);
			this.label2.TabIndex = 14;
			this.label2.Text = "Movement Mode";
			// 
			// RobotClient
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(824, 454);
			this.Controls.Add(this.groupBox3);
			this.Controls.Add(this.groupBox2);
			this.Controls.Add(this.groupBox1);
			this.Controls.Add(this.btnConnect);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.txtIP);
			this.Name = "RobotClient";
			this.Text = "Robot Client";
			this.Load += new System.EventHandler(this.RobotClient_Load);
			this.Closed += new System.EventHandler(this.Form1_Close);
			this.groupBox1.ResumeLayout(false);
			this.groupBox2.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.tbImageRefresh)).EndInit();
			this.groupBox3.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.tbSpeed)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new RobotClient());
		}

		private void addStatus(string message)
		{
			//txtStatus.Text = txtStatus.Text +  message + System.Environment.NewLine;
			txtStatus.AppendText(message + System.Environment.NewLine);
		}

		private void btnFoward_Click(object sender, System.EventArgs e)
		{
			if(frontf == false)
			{
				send(movementType + "fwd\n");
			}
			else if(frontf == true)
			{
				addStatus("If you go foward you will crash");
			}
		}

		private void btnRight_Click(object sender, System.EventArgs e)
		{
			if(rightf == false)
			{
				send(movementType + "rit\n");
			}
			else
			{
				addStatus("If you turn right you will crash");
			}
		}

		private void btnBack_Click(object sender, System.EventArgs e)
		{
			send(movementType + "bak\n");
		}

		private void btnLeft_Click(object sender, System.EventArgs e)
		{
			if(leftf == false)
			{
				send(movementType + "lef\n");
			}
			else
			{
				addStatus("If you turn left you will crash");
			}
		}
		private void btnStop_Click(object sender, System.EventArgs e)
		{
			btnFoward.Enabled = true;
			btnBack.Enabled = true;
			btnLeft.Enabled = true;
			btnRight.Enabled = true;
			btnAuto.Enabled = true;
			this.BackColor = defColor;
			send("stp\n" );
		}

		private void send(string command)
		{
			try
			{
				byte[] bytes = Encoding.ASCII.GetBytes(command);
				commandStream.Write(bytes, 0, bytes.Length);
			}
			catch(System.Net.Sockets.SocketException es)
			{
				addStatus("The server is not responding");
			}
			catch(System.Exception ex)
			{
			}

		}

		private void btnConnect_Click(object sender, System.EventArgs e)
		{
			string address = txtIP.Text;
			int port = 9988;

			addStatus("Attempting to connect to " + address + ":" + port.ToString() + "...");
			connect(address, port);
						
		}

		private void connect(string address, int port)
		{
			

			try
			{

				//connect the incoming stream
				connectionIn = new TcpClient(address, 9987);
				feedbackStream = connectionIn.GetStream();
				
				//connect the outgoing stream
				connectionOut = new TcpClient(address, 9988);
				commandStream = connectionOut.GetStream();
				
				//connect the image stream
				connectionImg = new TcpClient(address, 9986);
				imageStream = connectionImg.GetStream();



				String hostName = System.Net.Dns.GetHostName();
				IPHostEntry ipEntry = System.Net.Dns.GetHostByName(hostName);
				IPAddress[] addr = ipEntry.AddressList;

				send("new\n"+ addr[0] + "\n");


				//btnStop.Enabled = btnFoward.Enabled = btnLeft.Enabled = btnRight.Enabled = btnBack.Enabled =  true;
				groupBox3.Enabled = true;
				//feedbackThread = new Thread(new ThreadStart(getFeedback));
				//feedbackThread.Start();

				startFeedbackStream();

				startImageStream();
				addStatus("Connected");
			}
			catch(System.Net.Sockets.SocketException es)
			{
				addStatus("The server is not responding");
			}


		}

		private void startFeedbackStream()
		{

				getFeedbackTimer = new System.Timers.Timer();
				getFeedbackTimer.Elapsed += new System.Timers.ElapsedEventHandler(getFeedback);
				getFeedbackTimer.Interval = 100;
				getFeedbackTimer.Start();

		}
		private void getFeedback(object sender, ElapsedEventArgs e)
		{
			float left, right, front, bottom; 
			string alert;
			//getFeedbackTimer.Stop();
			try
			{
				byte[] bytes = Encoding.ASCII.GetBytes("get\n");
				feedbackStream.Write(bytes, 0, bytes.Length);
				StreamReader reader = new StreamReader(feedbackStream);

				left = Convert.ToSingle(reader.ReadLine()); //get left value
				front = Convert.ToSingle(reader.ReadLine()); //get front value
				right = Convert.ToSingle(reader.ReadLine()); //get right value		
				bottom = Convert.ToSingle(reader.ReadLine()); //get bottom value
				alert = reader.ReadLine();

				if(alert == "det") //neural net has detected anomaly
				{
					alertMode();
					addStatus("INTRUDER ALERT");
				}
				if(alert == "nav") //error while execution navigation script
				{
					alertMode();
					addStatus("An error has occured while executing the navigation script. Please use manual control to point the robot in the direction of the next checkpoint and re-engage autonomous mode");
				}

				warnings(left, right, front, bottom);

				
			}
			catch(System.Exception es)  //if an error occurs in the stream, close it and reopen
			{
			}
			//getFeedbackTimer.Start();
		
		}
		private void alertMode()
		{
			send("stp");
			this.BackColor = System.Drawing.Color.Red;

		}
		private void warnings(float left, float right, float front, float bottom)
		{

			//check left side
			if(left > 300 && leftf == false)
			{
				addStatus("Proximity warning on left side");
				leftf = true;
			}
			if(left < 300)
			{
				leftf = false;
			}

			//check right side
			if(right > 300 && rightf == false)
			{
				addStatus("Proximity warning on right side");
				rightf = true;
			}
			if(right < 300)
			{
				rightf = false;
			}

			//check front
			if(front > 300 && frontf == false)
			{
				addStatus("Proximity warning in front");
				frontf = true;
			}
			if(front < 300)
			{
				frontf = false;
			}

			//check bottom
			if(bottom < 30 && bottomf == false)
			{
				//addStatus("You have crossed a tape boundary");
				bottomf = true;
			}
			if(bottom > 30)
			{
				bottomf = false;
			}


		}

		private void disconnect()
		{

			send("ext\n");
			connectionOut.Close();
			commandStream.Close();
			connectionIn.Close();
			connectionImg.Close();
			try
			{
				byte[] bytes = Encoding.ASCII.GetBytes("ext\n");

				imageStream.Write(bytes, 0, bytes.Length);
				imageStream.Close();

				feedbackStream.Write(bytes, 0, bytes.Length);
				feedbackStream.Close();
			}
			catch(System.Exception e){Console.WriteLine(e.Message);}

		}

		private void Form1_Close(object sender, System.EventArgs e)
		{
			if(connectionOut != null)
			{
				disconnect();
			}
		
		}

		private void rdoInc_CheckedChanged(object sender, System.EventArgs e)
		{
			movementType = "inc\n";
		}

		private void rdoCont_CheckedChanged(object sender, System.EventArgs e)
		{
			movementType = "con\n";
		}

		private void tbSpeed_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			send("spd\n" + tbSpeed.Value.ToString() + "\n");
		}



		private void startImageStream()
		{
			getImageTimer = new System.Timers.Timer();
			getImageTimer.Elapsed += new System.Timers.ElapsedEventHandler(getImage);
			getImageTimer.Interval = tbImageRefresh.Value;
			getImageTimer.Enabled = true;

		}
		private void setImage(Image img)
		{
			picVideo.Image = img;//img.GetThumbnailImage(picVideo.Width, picVideo.Height,  new System.Drawing.Image.GetThumbnailImageAbort(ThumbnailCallback), IntPtr.Zero);
		}



		private void getImage(object sender, ElapsedEventArgs e)
		{
			getImageTimer.Enabled = false;
			try
			{
				byte[] bytes = Encoding.ASCII.GetBytes("get\n");
				imageStream.Write(bytes, 0, bytes.Length);

			    StreamReader reader = new StreamReader(imageStream);
				BinaryReader binreader = new BinaryReader(imageStream);

				int size = Convert.ToInt32(reader.ReadLine()); //get size of the image

				bytes = binreader.ReadBytes(size);

				MemoryStream ms = new MemoryStream(bytes, 0, bytes.Length);

				Image img = Image.FromStream(ms);

				setImage(img);
				getImageTimer.Enabled = true;

			}
			catch(System.Exception es)  //if an error occurs in the stream, close it and reopen
			{
				getImageTimer.Enabled = false;
				try
				{
					
					//addStatus("image problem");
					Console.WriteLine(es.Message);


					byte[] bytes = Encoding.ASCII.GetBytes("err\n");
					imageStream.Write(bytes, 0, bytes.Length);
					imageStream.Close();

					connectionImg = new TcpClient(txtIP.Text, 9986);
					imageStream = connectionImg.GetStream();

					startImageStream();
				}
				catch(System.Exception ex){}



			}


		
		}

		public bool ThumbnailCallback()
		{
			return true;
		}

		private void tbImageRefresh_Scroll(object sender, System.EventArgs e)
		{
			getImageTimer.Interval = tbImageRefresh.Value;
		}

		private void btnAuto_Click(object sender, System.EventArgs e)
		{
			btnFoward.Enabled = false;
			btnBack.Enabled = false;
			btnLeft.Enabled = false;
			btnRight.Enabled = false;
			btnAuto.Enabled = false;
			send("auto\n");
		
		}

		private void RobotClient_Load(object sender, System.EventArgs e)
		{
			defColor = this.BackColor;
		}


	}
}
