/***********************************
 *        Timothy Hannafin         *
 *        hannafit@wpi.edu         *
 * Worcester Polytechnic Institute *
 *               2006              *
 * *********************************/
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;


namespace RobotController
{
	/// <summary>
	/// Conotroller provides a GUI and some basic commands, mostly for debugging purposes
	/// </summary>
	public class Controller : System.Windows.Forms.Form
	{
		Robot myRobot = new Robot();
		Server myServer;

		public float speed = 0;
		private System.Windows.Forms.Button btnStop;
		private System.Windows.Forms.Button btnRight;

		private System.Windows.Forms.Button btnLeft;
		private System.Windows.Forms.Button btnBack;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Button btnStopServer;
		private System.Windows.Forms.Button btnFoward;
		public System.Windows.Forms.TextBox txtStatus;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.TrackBar trackBar1;
		public System.Windows.Forms.TextBox txtSpeed;
		private System.Windows.Forms.Button btnStartServer;
		public System.Windows.Forms.PictureBox picVideo;
		private System.Windows.Forms.Label label3;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Controller()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.txtSpeed = new System.Windows.Forms.TextBox();
			this.btnStop = new System.Windows.Forms.Button();
			this.btnRight = new System.Windows.Forms.Button();
			this.btnLeft = new System.Windows.Forms.Button();
			this.btnBack = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.btnStartServer = new System.Windows.Forms.Button();
			this.btnStopServer = new System.Windows.Forms.Button();
			this.btnFoward = new System.Windows.Forms.Button();
			this.txtStatus = new System.Windows.Forms.TextBox();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.label3 = new System.Windows.Forms.Label();
			this.picVideo = new System.Windows.Forms.PictureBox();
			this.label2 = new System.Windows.Forms.Label();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.trackBar1 = new System.Windows.Forms.TrackBar();
			this.groupBox1.SuspendLayout();
			this.groupBox2.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.trackBar1)).BeginInit();
			this.SuspendLayout();
			// 
			// txtSpeed
			// 
			this.txtSpeed.Location = new System.Drawing.Point(88, 32);
			this.txtSpeed.Name = "txtSpeed";
			this.txtSpeed.Size = new System.Drawing.Size(24, 20);
			this.txtSpeed.TabIndex = 1;
			this.txtSpeed.Text = "20";
			this.txtSpeed.TextChanged += new System.EventHandler(this.txtSpeed_TextChanged);
			// 
			// btnStop
			// 
			this.btnStop.Location = new System.Drawing.Point(144, 144);
			this.btnStop.Name = "btnStop";
			this.btnStop.Size = new System.Drawing.Size(56, 32);
			this.btnStop.TabIndex = 2;
			this.btnStop.Text = "Stop";
			this.btnStop.Click += new System.EventHandler(this.btnStop_Click);
			// 
			// btnRight
			// 
			this.btnRight.Location = new System.Drawing.Point(216, 144);
			this.btnRight.Name = "btnRight";
			this.btnRight.Size = new System.Drawing.Size(72, 32);
			this.btnRight.TabIndex = 4;
			this.btnRight.Text = "Turn Right";
			this.btnRight.Click += new System.EventHandler(this.btnRight_Click);
			// 
			// btnLeft
			// 
			this.btnLeft.Location = new System.Drawing.Point(72, 144);
			this.btnLeft.Name = "btnLeft";
			this.btnLeft.Size = new System.Drawing.Size(64, 32);
			this.btnLeft.TabIndex = 5;
			this.btnLeft.Text = "Turn Left";
			this.btnLeft.Click += new System.EventHandler(this.btnLeft_Click);
			// 
			// btnBack
			// 
			this.btnBack.Location = new System.Drawing.Point(144, 192);
			this.btnBack.Name = "btnBack";
			this.btnBack.Size = new System.Drawing.Size(56, 32);
			this.btnBack.TabIndex = 6;
			this.btnBack.Text = "Back";
			this.btnBack.Click += new System.EventHandler(this.btnBack_Click);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 32);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(72, 32);
			this.label1.TabIndex = 7;
			this.label1.Text = "Base Speed:";
			// 
			// btnStartServer
			// 
			this.btnStartServer.Location = new System.Drawing.Point(40, 336);
			this.btnStartServer.Name = "btnStartServer";
			this.btnStartServer.Size = new System.Drawing.Size(96, 24);
			this.btnStartServer.TabIndex = 9;
			this.btnStartServer.Text = "Start Server";
			this.btnStartServer.Click += new System.EventHandler(this.btnStartServer_Click);
			// 
			// btnStopServer
			// 
			this.btnStopServer.Location = new System.Drawing.Point(152, 336);
			this.btnStopServer.Name = "btnStopServer";
			this.btnStopServer.Size = new System.Drawing.Size(96, 24);
			this.btnStopServer.TabIndex = 10;
			this.btnStopServer.Text = "Stop Server";
			this.btnStopServer.Click += new System.EventHandler(this.btnStopServer_Click);
			// 
			// btnFoward
			// 
			this.btnFoward.Location = new System.Drawing.Point(144, 96);
			this.btnFoward.Name = "btnFoward";
			this.btnFoward.Size = new System.Drawing.Size(56, 32);
			this.btnFoward.TabIndex = 12;
			this.btnFoward.Text = "Foward";
			this.btnFoward.Click += new System.EventHandler(this.btnFoward_Click);
			// 
			// txtStatus
			// 
			this.txtStatus.BackColor = System.Drawing.SystemColors.HighlightText;
			this.txtStatus.Location = new System.Drawing.Point(16, 72);
			this.txtStatus.Multiline = true;
			this.txtStatus.Name = "txtStatus";
			this.txtStatus.ReadOnly = true;
			this.txtStatus.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this.txtStatus.Size = new System.Drawing.Size(280, 248);
			this.txtStatus.TabIndex = 13;
			this.txtStatus.Text = "";
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.Add(this.label3);
			this.groupBox1.Controls.Add(this.picVideo);
			this.groupBox1.Controls.Add(this.label2);
			this.groupBox1.Controls.Add(this.btnStopServer);
			this.groupBox1.Controls.Add(this.btnStartServer);
			this.groupBox1.Controls.Add(this.txtStatus);
			this.groupBox1.Location = new System.Drawing.Point(464, 72);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(672, 384);
			this.groupBox1.TabIndex = 14;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Web Server";
			// 
			// label3
			// 
			this.label3.ImageAlign = System.Drawing.ContentAlignment.TopCenter;
			this.label3.Location = new System.Drawing.Point(432, 32);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(136, 24);
			this.label3.TabIndex = 16;
			this.label3.Text = "Video Feed";
			this.label3.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// picVideo
			// 
			this.picVideo.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.picVideo.Location = new System.Drawing.Point(320, 72);
			this.picVideo.Name = "picVideo";
			this.picVideo.Size = new System.Drawing.Size(320, 240);
			this.picVideo.TabIndex = 15;
			this.picVideo.TabStop = false;
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(64, 32);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(168, 32);
			this.label2.TabIndex = 14;
			this.label2.Text = "Server Status";
			this.label2.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.Add(this.btnStop);
			this.groupBox2.Controls.Add(this.btnFoward);
			this.groupBox2.Controls.Add(this.btnBack);
			this.groupBox2.Controls.Add(this.btnLeft);
			this.groupBox2.Controls.Add(this.btnRight);
			this.groupBox2.Controls.Add(this.txtSpeed);
			this.groupBox2.Controls.Add(this.label1);
			this.groupBox2.Controls.Add(this.trackBar1);
			this.groupBox2.Location = new System.Drawing.Point(56, 72);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(352, 384);
			this.groupBox2.TabIndex = 15;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "Local Conrol";
			// 
			// trackBar1
			// 
			this.trackBar1.Location = new System.Drawing.Point(120, 24);
			this.trackBar1.Maximum = 50;
			this.trackBar1.Minimum = 10;
			this.trackBar1.Name = "trackBar1";
			this.trackBar1.Size = new System.Drawing.Size(208, 45);
			this.trackBar1.TabIndex = 16;
			this.trackBar1.Value = 20;
			this.trackBar1.Scroll += new System.EventHandler(this.trackBar1_Scroll);
			// 
			// Controller
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(1168, 526);
			this.Controls.Add(this.groupBox2);
			this.Controls.Add(this.groupBox1);
			this.Name = "Controller";
			this.Text = "Server";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.groupBox1.ResumeLayout(false);
			this.groupBox2.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.trackBar1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Controller());
			
		}
		

#region net stuff

		private void btnStartServer_Click(object sender, System.EventArgs e)
		{
			disableLocalButtons();
			btnStartServer.Enabled = false;
			myServer = new Server(myRobot, this);
			myServer.Start();
		}
		private void btnStopServer_Click(object sender, System.EventArgs e)
		{
			myServer.stop();
			enableLocalButtons();

		}
		#endregion

#region local buttons
		public void disableLocalButtons()
		{
			btnStop.Enabled = false;
			btnLeft.Enabled = false;
			btnRight.Enabled = false;
			btnBack.Enabled = false;
			btnFoward.Enabled = false;
		}

		public void enableLocalButtons()
		{
			btnStop.Enabled = true;
			btnLeft.Enabled = true;
			btnRight.Enabled = true;
			btnBack.Enabled = true;
			btnFoward.Enabled = true;
		}

		
		private void btnStart_Click(object sender, System.EventArgs e)
		{
			myRobot.Status = StatusType.navigating;
			btnLeft.Enabled = false;
			btnRight.Enabled = false;
			btnBack.Enabled = false;
			btnFoward.Enabled = false;
			driver.Start();
		}

		private void btnFoward_Click(object sender, System.EventArgs e)
		{
				myRobot.setFowardSpeed(speed);
		}

		private void btnLeft_Click(object sender, System.EventArgs e)
		{
			myRobot.turnLeft(speed,1);
		}

		private void btnRight_Click(object sender, System.EventArgs e)
		{
			myRobot.turnRight(speed,1);
		}

		private void btnBack_Click(object sender, System.EventArgs e)
		{
			if(txtSpeed.Text!="")
			{
				float speed = Convert.ToSingle(txtSpeed.Text);
				myRobot.setReverseSpeed(speed);
				
			}
		}
		private void btnStop_Click(object sender, System.EventArgs e)
		{

			btnStop.Enabled = true;
			btnLeft.Enabled = true;
			btnRight.Enabled = true;
			btnBack.Enabled = true;
			btnFoward.Enabled = true;
			myRobot.Status = StatusType.idle;

			myRobot.stop();
		}
		#endregion

		private void Form1_Load(object sender, System.EventArgs e)
		{

			if(txtSpeed.Text != "")
			{
				speed = Convert.ToSingle(txtSpeed.Text);
			}
		}

		private void trackBar1_Scroll(object sender, System.EventArgs e)
		{
			speed = trackBar1.Value;
			txtSpeed.Text = speed.ToString();
		}

		private void txtSpeed_TextChanged(object sender, System.EventArgs e)
		{
			//myServer.setSpeed(Convert.ToSingle(txtSpeed.Text));
			speed = Convert.ToSingle(txtSpeed.Text);
		
		}



	}
}
